
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Properties;
import javax.jnlp.FileContents;
import javax.jnlp.FileSaveService;
import javax.jnlp.ServiceManager;
import javax.jnlp.UnavailableServiceException;
import org.freehep.graphics2d.VectorGraphics;
import org.freehep.graphicsio.emf.EMFGraphics2D;
import org.freehep.graphicsio.pdf.PDFGraphics2D;
import org.freehep.graphicsio.ps.PSGraphics2D;
import org.freehep.graphicsio.svg.SVGGraphics2D;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author schlandi
 */
public class SaveAsListener implements ActionListener {

	private Component parent;

	public SaveAsListener(Component parent) {
		this.parent = parent;
	}

	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		ByteArrayOutputStream bos = new ByteArrayOutputStream(20000);

		if ("ps".equals(command)) {
			Properties props = new Properties();
			props.setProperty("PageSize", "A4");
			VectorGraphics vg = new PSGraphics2D(bos, this.parent);
			vg.setProperties(props);
			vg.startExport();
			this.parent.print(vg);
			vg.endExport();
		} else if ("pdf".equals(command)) {
			Properties props = new Properties();
			props.setProperty("PageSize", "A4");
			VectorGraphics vg = new PDFGraphics2D(bos, this.parent);
			vg.setProperties(props);
			vg.startExport();
			this.parent.print(vg);
			vg.endExport();
		} else if ("svg".equals(command)) {
			VectorGraphics vg = new SVGGraphics2D(bos, this.parent);
			vg.startExport();
			this.parent.print(vg);
			vg.endExport();
		} else if ("emf".equals(command)) {
			VectorGraphics vg = new EMFGraphics2D(bos, this.parent);
			vg.startExport();
			this.parent.print(vg);
			vg.endExport();
		}

		try {
			FileSaveService saveService = (FileSaveService) ServiceManager.lookup("javax.jnlp.FileSaveService");
			FileContents fc = saveService.saveFileDialog("", null, new ByteArrayInputStream(bos.toByteArray()), null);
			bos.close();
		} catch (UnavailableServiceException ex) {
			ex.printStackTrace(System.err);
		} catch (IOException ex) {
			ex.printStackTrace(System.err);
		}

	}
}
